#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#ifdef __cplusplus
}
#endif

#include <stdio.h>
#include <stdlib.h>
#include <ggi/ggi.h>
#include <ggi/gii.h>

MODULE = GGI		PACKAGE = GGI		

PROTOTYPES: DISABLE

int
ggiInit()

int
ggiExit()

ggi_visual_t
ggiOpen(display, ...)
	const char *	display
	CODE:
	if ((items == 0) || (*display == 0)) {
		RETVAL = ggiOpen(NULL);
        }
	else {
		RETVAL = ggiOpen(display);
        }
	OUTPUT:
	RETVAL

int
ggiClose(vis)
	ggi_visual_t	vis

int
_get_mode(discard, visual, tm)
	void *		discard
	ggi_visual_t	visual
	ggi_mode *	tm
	CODE:
	RETVAL = ggiGetMode(visual, tm);
	OUTPUT:
	RETVAL

int
_set_mode(discard, visual, tm)
	void *		discard
	ggi_visual_t	visual
	ggi_mode *	tm
	CODE:
	RETVAL = ggiSetMode(visual, tm);
	OUTPUT:
	RETVAL

int
_set_simple_mode(discard, visual, xsize, ysize, frames, type)
	void *		discard
	ggi_visual_t	visual
	int	xsize
	int	ysize
	int	frames
	ggi_graphtype	type
	CODE:
	RETVAL = ggiSetSimpleMode(visual, xsize, ysize, frames, type);
	OUTPUT:
	RETVAL

int
_set_graph_mode(discard, visual, x, y, xv, yv, type)
	void *		discard
	ggi_visual_t	visual
	int	x
	int	y
	int	xv
	int	yv
	ggi_graphtype	type
	CODE:
	RETVAL = ggiSetGraphMode(visual, x, y, xv, yv, type);
	OUTPUT:
	RETVAL

int
_set_text_mode(discard, visual, cols, rows, vcols, vrows, fontx, fonty, type)
	void *		discard
	ggi_visual_t	visual
	int	cols
	int	rows
	int	vcols
	int	vrows
	int	fontx
	int	fonty
	ggi_graphtype	type
	CODE:
	RETVAL = 
	ggiSetTextMode(visual, cols, rows, vcols, vrows, fontx, fonty, type);
	OUTPUT:
	RETVAL

int
_check_mode(discard, visual, tm)
	void *		discard
	ggi_visual_t	visual
	ggi_mode *	tm
	CODE:
	RETVAL = ggiCheckMode(visual, tm);
	OUTPUT:
	RETVAL

int
_check_simple_mode(discard, visual, xsize, ysize, frames, type, md)
	void *		discard
	ggi_visual_t	visual
	int	xsize
	int	ysize
	int	frames
	ggi_graphtype	type
	ggi_mode *	md
	CODE:
	RETVAL = ggiCheckSimpleMode(visual, xsize, ysize, frames, type, md);
	OUTPUT:
	RETVAL

int
_check_graph_mode(discard, visual, x, y, xv, yv, type, suggested_mode)
	void *		discard
	ggi_visual_t	visual
	int	x
	int	y
	int	xv
	int	yv
	ggi_graphtype	type
	ggi_mode *	suggested_mode
	CODE:
	RETVAL = ggiCheckGraphMode(visual, x, y, xv, yv, type, suggested_mode);
	OUTPUT:
	RETVAL

int
_check_text_mode(discard, visual, cols, rows, vcols, vrows, fontx, fonty, type, suggested_mode)
	void *		discard
	ggi_visual_t	visual
	int	cols
	int	rows
	int	vcols
	int	vrows
	int	fontx
	int	fonty
	ggi_graphtype	type
	ggi_mode *	suggested_mode
	CODE:
	RETVAL = ggiCheckTextMode(visual, cols, rows, vcols, vrows, fontx, fonty, type, suggested_mode);
	OUTPUT:
	RETVAL

int
_set_fg(discard, vis, color)
	void *		discard
	ggi_visual_t	vis
	ggi_pixel	color
	CODE:
	RETVAL = ggiSetGCForeground(vis, color);
	OUTPUT:
	RETVAL

int
_get_fg(discard, vis, color)
	void *		discard
	ggi_visual_t	vis
	ggi_pixel *	color
	CODE:
	RETVAL = ggiGetGCForeground(vis, color);
	OUTPUT:
	RETVAL

int
_set_bg(discard, vis, color)
	void *		discard
	ggi_visual_t	vis
	ggi_pixel	color
	CODE:
	RETVAL = ggiSetGCBackground(vis, color);
	OUTPUT:
	RETVAL

int
_get_bg(discard, vis, color)
	void *		discard
	ggi_visual_t	vis
	ggi_pixel *	color
	CODE:
	RETVAL = ggiGetGCBackground(vis, color);
	OUTPUT:
	RETVAL

int
_set_clip(discard, vis, left, top, right, bottom)
	void *		discard
	ggi_visual_t	vis
	int	left
	int	top
	int	right
	int	bottom
	CODE:
	RETVAL = ggiSetGCClipping(vis, left, top, right, bottom);
	OUTPUT:
	RETVAL

int
_get_clip(discard, vis, left, top, right, bottom)
	void *		discard
	ggi_visual_t	vis
	int	left
	int	top
	int	right
	int     bottom
	CODE:
	RETVAL = ggiGetGCClipping(vis, &left, &top, &right, &bottom);
	OUTPUT:
	RETVAL
	left
	top
	right
	bottom

int
_color_pal(discard, vis)
	void *		discard
	ggi_visual_t	vis
	CODE:
	RETVAL = ggiSetColorfulPalette(vis);
	OUTPUT:
	RETVAL

unsigned int
_pal_len(discard, vis)
	void *		discard
	ggi_visual_t	vis
	CODE:
	RETVAL = 0x80000000;
	while (RETVAL && ggiGetPalette(vis, RETVAL, 0, NULL)) 
		RETVAL = RETVAL >> 1;
	if (RETVAL) {
		int last;
		last = RETVAL << 1;
		while ((RETVAL <= last) && 
			ggiGetPalette(vis, last, 0, NULL)) last--;
		RETVAL = last;
        }
	OUTPUT:
	RETVAL


int
_pack (discard, vis, buf, cols, start, len)
	void *		discard
	ggi_visual_t	vis
	void *		buf
	ggi_color *	cols
	int		start
	int		len
	CODE:
	RETVAL = ggiPackColors(vis, buf, cols + start, len);
	OUTPUT:
	RETVAL

int
_unpack (discard, vis, buf, cols, start, len)
	void *		discard
	ggi_visual_t	vis
	void *		buf
	ggi_color *	cols
	int		start
	int		len
	CODE:
	RETVAL = ggiUnpackPixels(vis, buf, cols + start, len);
	OUTPUT:
	RETVAL

ggi_pixel
_map (discard, vis, col, where)
	void *		discard
	ggi_visual_t	vis
	ggi_color *	col
	int		where
	CODE:
	RETVAL = ggiMapColor(vis, col + where);
	OUTPUT:
	RETVAL

int
_unmap (discard, vis, pixval, cols, where)
	void *		discard
	ggi_visual_t	vis
	ggi_pixel	pixval
	ggi_color *	cols
	int		where
	CODE:
	RETVAL = ggiUnmapPixel(vis, pixval, cols + where);
	OUTPUT:
	RETVAL

int
_get_pal(discard, vis, s, len, cmap)
	void *		discard
	ggi_visual_t	vis
	int		s
	int		len
	ggi_color *	cmap
	CODE:	
	RETVAL = ggiGetPalette(vis, s, len, cmap);
	OUTPUT:
	RETVAL

int
_set_pal(discard, vis, s, len, cmap)
	void *		discard
	ggi_visual_t	vis
	int		s
	int		len
	ggi_color *	cmap
	CODE:	
	RETVAL = ggiSetPalette(vis, s, len, cmap);
	OUTPUT:
	RETVAL

int
_fill_screen(discard, vis)
	void *		discard
	ggi_visual_t	vis
	CODE:
	RETVAL = ggiFillscreen(vis);
	OUTPUT:
	RETVAL

int
_draw_pixel(discard, vis, x, y)
	void *		discard
	ggi_visual_t	vis
	int	x
	int	y
	CODE:
	RETVAL = ggiDrawPixel(vis, x, y);
	OUTPUT:
	RETVAL

int
_put_pixel(discard, vis, x, y, pixel)
	void *		discard
	ggi_visual_t	vis
	int	x
	int	y
	ggi_pixel	pixel
	CODE:
	RETVAL = ggiPutPixel(vis, x, y, pixel);
	OUTPUT:
	RETVAL

int
_put_pixel_buf(discard, vis, x, y, pixel)
	void *		discard
	ggi_visual_t	vis
	int	x
	int	y
	ggi_pixel *	pixel
	CODE:
	RETVAL = ggiPutPixel(vis, x, y, *pixel);
	OUTPUT:
	RETVAL

int
_draw_hline(discard, vis, x, y, w)
	void *		discard
	ggi_visual_t	vis
	int	x
	int	y
	int	w
	CODE:
	RETVAL = ggiDrawHLine(vis, x, y, w);
	OUTPUT:
	RETVAL

int
_put_hline(discard, vis, x, y, w, buf)
	void *		discard
	ggi_visual_t	vis
	int	x
	int	y
	int	w
	void *	buf
	CODE:
	RETVAL = ggiPutHLine(vis, x, y, w, buf);
	OUTPUT:
	RETVAL

int
_draw_vline(discard, vis, x, y, h)
	void *		discard
	ggi_visual_t	vis
	int	x
	int	y
	int	h
	CODE:
	RETVAL = ggiDrawVLine(vis, x, y, h);
	OUTPUT:
	RETVAL

int
_put_vline(discard, vis, x, y, h, buf)
	void *		discard
	ggi_visual_t	vis
	int	x
	int	y
	int	h
	void *	buf
	CODE:
	RETVAL = ggiPutVLine(vis, x, y, h, buf);
	OUTPUT:
	RETVAL

int
_draw_line(discard, vis, x, y, xe, ye)
	void *		discard
	ggi_visual_t	vis
	int	x
	int	y
	int	xe
	int	ye
	CODE:
	RETVAL = ggiDrawLine(vis, x, y, xe, ye);
	OUTPUT:
	RETVAL

int
_draw_box(discard, vis, x, y, w, h)
	void *		discard
	ggi_visual_t	vis
	int	x
	int	y
	int	w
	int	h
	CODE:
	RETVAL = ggiDrawBox(vis, x, y, w, h);
	OUTPUT:
	RETVAL

int
_get_box(discard, vis, x, y, w, h, buf)
	void *		discard
	ggi_visual_t	vis
	int	x
	int	y
	int	w
	int	h
	void *	buf
	CODE:
	RETVAL = ggiGetBox(vis, x, y, w, h, buf);
	OUTPUT:
	RETVAL

int
_put_box(discard, vis, x, y, w, h, buf)
	void *		discard
	ggi_visual_t	vis
	int	x
	int	y
	int	w
	int	h
	void *	buf
	CODE:
	RETVAL = ggiPutBox(vis, x, y, w, h, buf);
	OUTPUT:
	RETVAL

int
_copy_box(discard, vis, x, y, w, h, nx, ny)
	void *		discard
	ggi_visual_t	vis
	int	x
	int	y
	int	w
	int	h
	int	nx
	int	ny
	CODE:
	RETVAL = ggiCopyBox(vis, x, y, w, h, nx, ny);
	OUTPUT:
	RETVAL

int
_put_s(discard, vis, x, y, str)
	void *		discard
	ggi_visual_t	vis
	int	x
	int	y
	const char *	str
	CODE:
	RETVAL = ggiPuts(vis, x, y, str);
	OUTPUT:
	RETVAL

int
_flush(discard, vis)
	void *		discard
	ggi_visual_t	vis
	CODE:
	RETVAL = ggiFlush(vis);
	OUTPUT:
	RETVAL

int
_flush_region(discard, vis, x, y, w, h)
	void *		discard
	ggi_visual_t	vis
	int	x
	int	y
	int	w
	int	h
	CODE:
	RETVAL = ggiFlushRegion(vis, x, y, w, h);
	OUTPUT:
	RETVAL

ggi_pixelformat *
_clone_pixel_format(discard, vis)
	void *		discard
	ggi_visual_t	vis
	CODE:
	RETVAL = malloc(sizeof(ggi_pixelformat));
	memcpy(RETVAL, ggiGetPixelFormat(vis), sizeof(ggi_pixelformat));
	OUTPUT:
	RETVAL

gii_event *
gg_read(discard, vis, ev, mask)
	void *		discard
	ggi_visual_t	vis
	gii_event *	ev
	gii_event_mask	mask
	CODE:
	ggiEventRead(vis, ev, mask);
	RETVAL = ev;
	OUTPUT:
	RETVAL

int
gg_send(discard, vis, ev)
	void *		discard
	ggi_visual_t	vis
	gii_event *	ev
	CODE:
	RETVAL = ggiEventSend(vis, ev);
	OUTPUT:
	RETVAL

gii_event_mask
gg_poll_msec(discard, vis, mask, msec)
	void *		discard
	ggi_visual_t	vis
	gii_event_mask	mask
	uint32		msec
	CODE:
	struct timeval t;
	t.tv_sec = msec / 1000;
	t.tv_usec = (msec % 1000) * 1000;
	RETVAL = ggiEventPoll(vis, mask, &t);
	msec = t.tv_sec * 1000 + t.tv_usec/1000;
	OUTPUT:
	RETVAL
	msec

int
gg_queued(discard, vis, mask)
	void *		discard
	ggi_visual_t	vis
	gii_event_mask	mask
	CODE:
	RETVAL = ggiEventsQueued(vis, mask);
	OUTPUT:
	RETVAL

gii_event_mask
gg_get_mask(discard, vis)
	void *		discard
	ggi_visual_t	vis
	CODE:
	RETVAL = ggiGetEventMask(vis);
	OUTPUT:
	RETVAL

int
gg_set_mask(discard, vis, evm)
	void *		discard
	ggi_visual_t	vis
	gii_event_mask	evm
	CODE:
	RETVAL = ggiSetEventMask(vis, evm);
	OUTPUT:
	RETVAL

